<?php

function evaluate() {
	$function = getSAPRFCFunction('RFC_ABAP_INSTALL_AND_RUN');
	$source_tab = 'PROGRAM';
	$result_tab = 'WRITES';
	saprfc_table_init($function, $source_tab);
	saprfc_table_init($function, $result_tab);

	saprfc_import ($function, 'MODE', 'F');
	saprfc_import ($function, 'PROGRAMNAME', 'zabap_console');

	
	$source = str_replace("\r", "", $_POST['source']);
	$source = "REPORT zabap_console." . $source;
	$source = explode("\n", stripslashes($source));
	
	foreach ($source AS $line) {
		saprfc_table_append($function, $source_tab, array('LINE' => $line));
	}
	
	saprfc_call_and_receive($function);
	$result = array();
	$rows = saprfc_table_rows($function, $result_tab);
	for ($i = 1; $i <= $rows; $i++) {  // ABAP tables start at 1
		$result_line = saprfc_table_read($function, $result_tab, $i);
		$result[] = addslashes($result_line['ZEILE']);
		
	}
	
	if (empty($result)) {
		$err = saprfc_export($function, 'ERRORMESSAGE');
		if ($err) {
			
			$function = getSAPRFCFunction('ZSTOYAN_RFC_SYNTAX_CHECK');
			$source_tab = 'SOURCE';
			saprfc_table_init($function, $source_tab);
			foreach ($source AS $line) {
				saprfc_table_append($function, $source_tab, array('LINE' => $line));
			}
			saprfc_call_and_receive($function);
			$message = saprfc_export($function, 'MESSAGE');
			if (!$message) {
				$result[] = addslashes($err);
			} else {
				$line    = saprfc_export($function, 'LINE');
				$word    = saprfc_export($function, 'WORD');
				$result  = '{error:{message:"'
									 . addslashes($message) . '", line:"'
									 . addslashes($line) .'", word:"'
									 . addslashes($word) .'"}}'; 
				
				
				return $result;
			}
			
			
		}
	}
	
	return array2JSON($result);
}


function hilite() {

	// figure out the if ":" or ";" should be used for ini separators
	if (strpos(strtoupper(PHP_OS), "WIN") !== false) {
	    define("INI_PATH_SEPARATOR", ";");
	} else {
	    define("INI_PATH_SEPARATOR", ":");
	}
	// add PEAR to the path
	ini_set(
	        "include_path", 
	        ini_get("include_path") . INI_PATH_SEPARATOR . 
	        realpath("../_extras/pear")
	       );


  require_once 'Text/Highlighter.php';
  require_once 'Text/Highlighter/Renderer/JSON.php';
  $json_options['tabsize'] = 4;
  $json_options['enumerated'] = true; 
  $renderer =& new Text_Highlighter_Renderer_JSON($json_options);
  $highlighter =& Text_Highlighter::factory('abap');
  $highlighter->setRenderer($renderer);
  return $highlighter->highlight(stripslashes($_POST['source']));

}


// utilities
function getSAPRFCConnection() {
	if (empty($GLOBALS['rfc'])) {
		$connection_options = array (
			'USER'		=> 'username', 
			'PASSWD' 	=> 'password',
			'R3NAME'  => 'R3N',
		);

		$GLOBALS['rfc'] = saprfc_open($connection_options);
	}
	return $GLOBALS['rfc'];
}

// Discovers the function interface and stores it
// in the session. Returns the stored interface
// on consecutive calls
function getSAPRFCFunction($function_name) {
	$rfc = getSAPRFCConnection();
	if (empty($_SESSION['interfaces'][$function_name])) {
		$rfc_function = saprfc_function_discover($rfc, $function_name);
		$_SESSION['interfaces'][$function_name] = saprfc_function_interface($rfc_function);
	} else {
		$rfc_function = saprfc_function_define($rfc, $function_name, $_SESSION['interfaces'][$function_name]);
	}
	return $rfc_function;
} 

function array2JSON($array, $quotes = true) {

	if ($quotes) {
		$json = '["' . implode('","', $array) . '"]';
	} else {
		$json = '[' . implode(',', $array) . ']';
	}
	return $json;
}

?>
